var travelmathApp = angular.module('travelmath', ['ionic', 'ngCordova', 'uiGmapgoogle-maps', 'ngMessages']);

travelmathApp.run(['$ionicPlatform', '$cordovaSplashscreen', function($ionicPlatform, $cordovaSplashscreen) {
    $ionicPlatform.ready(function() {
        if(window.cordova && window.cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            cordova.plugins.Keyboard.disableScroll(true);
        }
        if(window.StatusBar) {
            StatusBar.hide();
        }
        setTimeout(function() {
            $cordovaSplashscreen.hide();
        }, 1000 );
    });
}])

.config(function($stateProvider, $urlRouterProvider, uiGmapGoogleMapApiProvider) {

    $stateProvider
        .state('main', {
            url: '/',
            templateUrl: 'views/main.html',
            controller: 'mainCtrl'
        })
        .state('locations', {
            url: '/locations',
            templateUrl: 'views/locations.html',
            controller: 'locationsCtrl'
        });

        $urlRouterProvider.otherwise('/');

        uiGmapGoogleMapApiProvider.configure({
            //    key: 'your api key',
            v: '3.20',
            sensor: false,
            libraries: 'geometry'
        });

});

travelmathApp.constant('ApiUrl', 'http://www.travelmath.com/api/v2/mobile?key=bW9iaWxlLWFwcC12Mg&');
travelmathApp.constant('AutoApiUrl', 'http://www.travelmath.com/api/v2/autocomplete?key=YXV0b2NvbXBsZXRlLXYy&term=');

travelmathApp.run(['$ionicPlatform', 'checkConnection', 'locationGeoData', 'modal', '$rootScope', '$location', function($ionicPlatform, checkConnection, locationGeoData, modal, $rootScope, $location) {
    $ionicPlatform.ready(function() {

        checkConnection.do();
        locationGeoData.get();
        modal.setup();

        // Refresh the users location and apply city and country to from field. Emtpy to field.
        $rootScope.$on('$locationChangeSuccess', function(event, next, current) {
            if( $location.path() === '/' ) {
                locationGeoData.get();
            }
        });

        /**
        * @param {Number} degree - UIInterfaceOrientationPortrait: 0, UIInterfaceOrientationLandscapeRight: 90, UIInterfaceOrientationLandscapeLeft: -90, UIInterfaceOrientationPortraitUpsideDown: 180
        * @returns {Boolean} Indicating if rotation should be allowed.
        */
        window.shouldRotateToOrientation = function(degrees) {
            return true;
        };

    });
}]);