travelmathApp.directive('googleAutocomplete', [ 'carrier', '$timeout', '$ionicTemplateLoader', '$document', '$compile', '$ionicScrollDelegate', '$http', 'AutoApiUrl', '$q', function(carrier, $timeout, $ionicTemplateLoader, $document, $compile, $ionicScrollDelegate, $http, AutoApiUrl, $q) {
    return {
        require : 'ngModel',
        restrict: 'A',
        template: '<input type="text" ng-click="onClick()" ng-focus="onClick();$event.preventDefault();$event.stopPropagation();" autocomplete="off" class="google-autocomplete">',
        replace: true,
        scope : {
            model : '=ngModel',
            ngCalculate : '&',
            ngFromto : '&'
        },
        link : function(scope, element, attrs, model) {
            var options = {
                types : [],
            };

            // uiGmapGoogleMapApi.then(function(maps) {

                var LIST = [
                    '<ion-list>',
                        '<ion-item ng-repeat="location in locations" type="item-text-wrap" ng-click="selectLocation(location)">',
                            '{{location.value}}',
                        '</ion-item>',
                    '</ion-list>'
                ].join('');

                var listPromise = $ionicTemplateLoader.compile({
                    template: LIST,
                    scope: scope,
                    appendTo: element.parent()
                });

                listPromise.then(function(el) {

                    var searchEventTimeout;

                    scope.$watch('model', function (query) {
                        if( typeof query === 'undefined' || query.length < 4 ) {
                            scope.locations = {};
                            return;
                        }

                        if (searchEventTimeout) {
                            $timeout.cancel(searchEventTimeout);
                        }
                        searchEventTimeout = $timeout(function () {
                            if (!query) {
                                return;
                            }

                            //https://developers.google.com/maps/documentation/javascript/places-autocomplete
                            //https://developers.google.com/maps/documentation/javascript/reference#AutocompleteService
                            // var service = new maps.places.AutocompleteService();
                            // service.getPlacePredictions({ input: query, types: ['(cities)'] }, function(results, status) {
                            //     if (status === maps.places.PlacesServiceStatus.OK) {
                            //         scope.$apply(function () {
                            //             scope.locations = results;
                            //         });
                            //     }
                            // });

                            var requestUrl = AutoApiUrl + query;

                            $http.get(requestUrl, {}).success(function(response) {
                                // scope.$apply(function() {
                                    scope.locations = response;
                                // });
                            });

                        }, 350);
                    });

                    scope.selectLocation = function (location) {
                        // For google api
                        // var $query;
                        // if( location.terms[2] && location.terms[2].value.toUpperCase() === 'UNITED STATES' ) {
                        //     $query = location.terms[0].value + ', ' + location.terms[1].value;
                        // } else if( location.terms[1] ) {
                        //     var stateOrCountry = (location.terms[2] ? location.terms[2].value : location.terms[1].value);
                        //     $query = location.terms[0].value + ', ' + stateOrCountry;
                        // } else {
                        //     $query = location.terms[0].value;
                        // }

                        model.$setViewValue(location.value);
                        model.$render();

                        // element.parent().next().find('input').focus();

                        el.element.css('display', 'none');
                        element.parent().removeClass('autocomplete_parent');
                        var form = element.parent().parent(),
                            elParent = element.parent();

                        $ionicScrollDelegate.resize();

                        if( !form.hasClass('disableAutoSubmit') && !elParent.hasClass('noAutoSubmitFromField') ) {
                            //submit the form if both are filled out
                            var cal = scope.ngFromto();// use the getter
                            if( (cal.to && cal.from) || (cal.FromLocation && cal.ToLocation) ) {
                                if( form.hasClass('autosubmitonce') ) {
                                    form.addClass('disableAutoSubmit');
                                }
                                scope.ngCalculate();
                            }
                        }
                    };

                    scope.onClick = function (e) {
                        // Remove class autocomplete_parent from previous
                        var lastInput = document.getElementsByClassName('autocomplete_parent');
                        if( lastInput.length > 0 ) {
                            var old = angular.element(lastInput[0]);
                                old.removeClass('autocomplete_parent');
                                old.find('ion-list').css('display', 'none');
                        }
                        scope.locations = {};
                        // angular.element($document[0].body).addClass('autocomplete_active');// autocomplete is active
                        el.element.css('display', 'block');
                        element.parent().addClass('autocomplete_parent');

                        $ionicScrollDelegate.resize();
                    };

                    angular.element($document).on('click', function(e) {
                        e.stopPropagation();
                        if( e.target.tagName.toUpperCase() !== 'INPUT' && e.target.tagName.toUpperCase() !== 'ION-ITEM') {
                            el.element.css('display', 'none');
                            angular.element($document[0].body).removeClass('autocomplete_active');// autocomplete is in-active
                            angular.element($document[0].body).removeClass('animate_form_up');// autocomplete is in-active
                            element.parent().removeClass('autocomplete_parent');
                        }

                        $ionicScrollDelegate.resize();
                    });

                });

            // });// uiGmapGoogleMapApi
        }
    };
}]);