travelmathApp.factory('Geo', [ '$q', 'uiGmapGoogleMapApi', function($q, uiGmapGoogleMapApi) {
    return {
        reverseGeocode: function(lat, lng) {
            var q = $q.defer();

            uiGmapGoogleMapApi.then(function(maps) {
                var geocoder = new maps.Geocoder();
                geocoder.geocode({
                    'latLng': new maps.LatLng(lat, lng)
                }, function(results, status) {
                    if (status == google.maps.GeocoderStatus.OK) {
                        if (results.length > 1) {
                            var r = results[1];
                            var a, types;
                            var parts = [];
                            var foundLocality = false;
                            var foundState = false;
                            for (var i = 0; i < r.address_components.length; i++) {
                                a = r.address_components[i];
                                types = a.types;
                                for (var j = 0; j < types.length; j++) {
                                    if (!foundLocality && types[j] == 'locality') {
                                        foundLocality = true;
                                        parts.push(a.long_name);
                                    } else if (!foundState && types[j] == 'administrative_area_level_1') {
                                        foundState = true;
                                        parts.push(a.short_name);
                                    }
                                }
                            }
                            q.resolve(parts.join(', '));
                        }
                    } else {
                        q.reject(results);
                    }
                });
            });

            return q.promise;
        }
    };
}]);