travelmathApp.factory('locationGeoData', ['Geo', '$rootScope', '$cordovaGeolocation', '$ionicPopup',  function( Geo, $rootScope, $cordovaGeolocation, $ionicPopup) {
    return {

        get: function() {
            $rootScope.cal = {};
            // Default & Re-Locate Change Variables to False
            $rootScope.currentLocationString = '';
            $rootScope.currentLatHtml = '';
            $rootScope.currentLngHtml = '';
            $rootScope.locationLoading = true;

            var posOptions = {enableHighAccuracy: false};
            $cordovaGeolocation.getCurrentPosition(posOptions)
            .then(this.successGeo, function(error) {
                $rootScope.locationLoading = false;
                $ionicPopup.alert({
                    title: 'Unable to get location',
                    template: 'Turn on Location Services or fill out the To and From Manually'
                });
            });

            // Watch position
            // var watchOptions = {frequency : 1000,timeout : 3000,enableHighAccuracy: false},
            //     watch = $cordovaGeolocation.watchPosition(watchOptions);
            //     watch.then(null, function() {
            //         //error, dismiss for watch
            //     }, successGeo);

                // clear watch
                // watch.clearWatch();
        },

        successGeo: function(position) {

            var lat = position.coords.latitude,
                lng = position.coords.longitude;

            Geo.reverseGeocode(lat, lng).then(function(locString) {
                $rootScope.currentLocationString = locString;
                $rootScope.cal.from = locString;

                // Latitude Degrees
                var tmp = Math.abs(lat);
                var LatDeg = Math.floor(tmp);
                tmp -= LatDeg;
                var LatMin = Math.floor(60 * tmp + 0.0001);
                tmp = 60*tmp - LatMin;
                var LatSec = Math.floor(60 * tmp + 0.0001);
                if (lat < 0) {
                var LatDir = "S";
                } else {
                var LatDir = "N";
                }

                // Lognitude Degrees
                tmp = Math.abs(lng);
                var LongDeg = Math.floor(tmp);
                tmp -= LongDeg;
                var LongMin = Math.floor(60 * tmp + 0.0001);
                tmp = 60*tmp - LongMin;
                var LongSec = Math.floor(60 * tmp + 0.0001);
                if (lng < 0) {
                var LongDir = "W";
                } else {
                var LongDir = "E";
                }

                var degree = '&deg; ';

                var latDegree = LatDeg + degree + LatMin + "' " + LatSec + "\" " + LatDir;
                var lngDegree = LongDeg + degree + LongMin + "' " + LongSec + "\" " + LongDir;

                $rootScope.currentLatHtml = latDegree;
                $rootScope.currentLngHtml = lngDegree;
                $rootScope.locationLoading = false;
            });

        },

        loaderOnOff: function(set) {
            $rootScope.locationLoading = set;
        }
    };
}]);