travelmathApp.factory('modal', ['$rootScope', '$localstorage', '$ionicModal', '$location', function($rootScope, $localstorage, $ionicModal, $location) {
    return {

        setup: function() {
            $rootScope.isIos = ionic.Platform.isIOS();
            $rootScope.isAndroid = ionic.Platform.isAndroid();
            /**
            * MODAL TEMP
            */
            $ionicModal.fromTemplateUrl('contact-modal.html', {
                scope: $rootScope,
                animation: 'slide-in-up'
            }).then(function(modal) {
                $rootScope.modal = modal;
            });
            $rootScope.openModal = function() {
                $rootScope.settings = $localstorage.getObject('settings');
                $rootScope.modal.show();
            };
            $rootScope.saveModal = function(form) {

                if( !form.$valid ) {
                    return;
                }

                var mpg = +$rootScope.settings.mpg,
                    obj = {};

                var testmpg = /^\d{1,2}$/.test(mpg);
                if( testmpg ) {
                    obj.mpg = mpg;
                } else {
                    $rootScope.settings.mpg = 0;
                    obj.mpg = 0;
                }

                var gas = +$rootScope.settings.gas;
                var test = /^\d{1,2}(?:\.\d{1,3})?$/.test(gas);

                if( test ) {
                    obj.gas = gas;
                } else {
                    $rootScope.settings.gas = 0;
                    obj.gas = 0;
                }

                //set the object
                $localstorage.setObject('settings', obj);

                // Close Keyboard
                cordova.plugins.Keyboard.close();

                $rootScope.modal.hide();
                $rootScope.$broadcast('refresh-required');
            };
            //Cleanup the modal when we're done with it!
            $rootScope.$on('$destroy', function() {
                $rootScope.modal.remove();
            });
            // Execute action on hide modal
            $rootScope.$on('modal.hidden', function() {
                // Execute action
            });
            // Execute action on remove modal
            $rootScope.$on('modal.removed', function() {
                // Execute action
            });
        }
    };
}]);