travelmathApp.service('travelMathRequest', ['ApiUrl', '$rootScope', 'carrier', '$http', '$localstorage', '$q', '$filter', function(ApiUrl, $rootScope, carrier, $http, $localstorage, $q, $filter) {
    // Setup API Call for Locations Page
    var url = ApiUrl,
        config = {};

    this.calculate = function(values, redirect) {
        // Close Keyboard
        cordova.plugins.Keyboard.close();

        var settings = $localstorage.getObject('settings');

        // encode the values from the form
        var from = encodeURIComponent(values.from || values.FromLocation),
            to = encodeURIComponent(values.to || values.ToLocation),
            mpg = encodeURIComponent(settings.mpg),
            gas = encodeURIComponent(settings.gas),
            requestUrl = url + 'from=' + from + '&to=' + to + '&mpg=' + mpg + '&gas=' + gas,
            deferred = $q.defer();

        $http.get(requestUrl, config).success(function(response) {
            var error = carrier.handler(response, redirect);

            if( error === false ) {
                deferred.resolve(response);
            } else {
                deferred.reject();
            }

        }).error(function() {
            deferred.reject();
        });

        return deferred.promise;
    };

    this.getCostAndUsage = function(data) {
        var settings = $localstorage.getObject('settings'),
            gas,mpg,gallons,liters,cost,out,gasFiltered;

        if( settings.mpg <= 0 || settings.mpg > 99 ) { mpg = 25; } else { mpg = settings.mpg; }

        if( settings.gas <= 0 || settings.gas > 99.99 ) { gas = data.Gas; } else { gas = settings.gas; }

        gas = parseFloat(Math.round(gas*100)/100).toFixed(2);  // round gas price and force it to 2 decimal places
        gallons = data.Miles/mpg;
        liters = gallons*3.7854118;
        cost = gallons*gas;
        gasFiltered = gas.split('.').pop() == 00 ? $filter('currency')(gas, '$', 0) : $filter('currency')(gas, '$', 2);

        return {
            CostOfDriving : $filter('currency')(parseFloat(Math.round(cost*100)/100), '$', 2) + '<br />' + mpg +
            ' mpg and ' + gasFiltered + '/gal',
            FuelUsage : parseFloat(Math.round(gallons*10)/10).toFixed(1) + ' gal / ' + parseFloat(Math.round(liters*10)/10).toFixed(1) + ' L'
        };

    };

}]);